# A Flow Component
flow = new FlowComponent
flow.showNext Screen_A

# A variable to keep track of when a swiping gesture started
weAreSwiping = no


## TAP EVENTS ##

# Tap on A ? -> Show screen B
Screen_A.onTap ->
	if not weAreSwiping			# but only when not currently swiping
		flow.showNext Screen_B

# Tap on B ? -> Show screen C
Screen_B.onTap ->
	if not weAreSwiping			# but only when not currently swiping
		flow.showNext Screen_C


## EDGE SWIPE EVENTS ##

# User started swiping from the left edge …
Screen.onEdgeSwipeLeftStart ->
	# … so now taps shouldn’t trigger anything
	weAreSwiping = yes

# We continuously adjust the x position of the «current» screen
# and of the «previous» screen underneath it
Screen.onEdgeSwipeLeft ->
	if flow.stack.length > 1	# only when not the first screen
		# Current screen
		flow.current.x = event.offset.x
		# Previous screen, will be hidden at first
		flow.previous.visible = yes
		# … and only moves at half the speed
		flow.previous.x = (event.offset.x / 2) - (flow.previous.width / 2)

# End of the swipe gesture
Screen.onEdgeSwipeLeftEnd ->
	if flow.stack.length > 1	# only when not the first screen
		# Panned less than half the screen width?
		# -> animate back to the initial position
		if event.offset.x < Screen.midX
			flow.current.animate
				x: 0
				options:
					curve: "spring(300, 35)"
			flow.previous.animate
				x: - (flow.previous.width / 2)
				options:
					curve: "spring(300, 35)"
		# Panned more than half the screen?
		# -> Trigger transition
		else
			flow.showPrevious()
	
	# Taps are allowed to happen again
	Utils.delay 0.1, ->
		weAreSwiping = no
